this.name = "Repair Nanobots";
this.author = "Thargoid";
this.copyright = "Creative Commons Attribution - Non-Commercial - Share Alike 3.0 license with clauses - see readme.txt.";
this.description = "Scan through a list of possible broken equipment, see what the player has, and then fix one of them";
this.version = "2.07";
"use strict";

this.repairSystems = function() 
	{
	this.playerDamagedList = [];
	var equipment = player.ship.equipment;
	var listCounter = 0 ; // reset the counter
	for(listCounter = 0;listCounter<equipment.length;listCounter++)
		{
		if(player.ship.equipmentStatus(equipment[listCounter].equipmentKey) !== "EQUIPMENT_DAMAGED")
			{ continue; }
		var scriptEq = EquipmentInfo.infoForKey(equipment[listCounter].equipmentKey);
		if(scriptEq.scriptInfo.thargoidRepairBotChance === undefined 
				|| isNaN(scriptEq.scriptInfo.thargoidRepairBotChance)
				|| (!isNaN(scriptEq.scriptInfo.thargoidRepairBotChance)
				&& scriptEq.scriptInfo.thargoidRepairBotChance > 0)
			)
			{ this.playerDamagedList.push(equipment[listCounter].equipmentKey); } // if it's broke and fixable, add it to the list.
		}
 
	if(this.playerDamagedList.length === 0)
		{
		player.consoleMessage("Nothing damaged that the repair bots can fix.", 5);
		return;
		}
	else
		{
		var damagedEquipment = Math.floor(Math.random() * this.playerDamagedList.length); // pick a random element from the list...
		this.fixedItem = this.playerDamagedList[damagedEquipment]; // ...define the item...
		this.fixedName = EquipmentInfo.infoForKey(this.fixedItem).name; // define it's screen name
		this.fixedTech = EquipmentInfo.infoForKey(this.fixedItem).effectiveTechLevel // tech level of the item

		switch(true) 
			{
			case (EquipmentInfo.infoForKey(this.fixedItem).scriptInfo.thargoidRepairBotChance !== undefined && !isNaN(EquipmentInfo.infoForKey(this.fixedItem).scriptInfo.thargoidRepairBotChance)): 
				{
				this.fixChance = EquipmentInfo.infoForKey(this.fixedItem).scriptInfo.thargoidRepairBotChance;
				break;
				}
			case (this.fixedTech < 9): 
				{ 
				this.fixChance = 1; 
				break; 
				}
			case ((this.fixedTech > 8) && (this.fixedTech < 17)): 
				{
				this.fixChance = 1 - ((this.fixedTech - 8)/10); 
				break;
				}
			case (this.fixedTech === 99): 
				{
				this.fixChance = 0.1; 
				break;
				}
			default: 
				{
				this.fixChance = 0.2; 
				break;
				}
			}
		}	
		
		if(Math.random() < this.fixChance)
			{ this.fixItem(); }
		else
			{ player.consoleMessage(this.fixedName + " repair attempt has failed.", 5); }
	}

this.fixItem = function()
	{
	player.ship.setEquipmentStatus(this.fixedItem,"EQUIPMENT_OK"); // and actually fix the thing!
	player.consoleMessage(this.fixedName + " fixed by the repair bots.", 5)
	switch(this.fixedItem) // specific OXP equipment which need rebooting after fixing, or have other issues.
		{
		case "EQ_FRAME_FUEL_COLLECTOR":
			{
			if(worldScripts["Fuel Collector"]) 
				{
				worldScripts["Fuel Collector"].shipLaunchedFromStation(); // restart the timers in it's world script
				break;
				}
			}
		case "EQ_FRAME_BOUNTY_SCANNER":			
			{
			if(worldScripts["Bounty Scanner"])
				{
				worldScripts["Bounty Scanner"].shipLaunchedFromStation(); // restart the timers in it's world script
				break;
				}
			}
		case "EQ_EEU":
			{
			if(worldScripts["Emergency Energy Unit"])
				{
				worldScripts["Emergency Energy Unit"].shipLaunchedFromStation(); // restart the timers in it's world script
				break;
				}
			}
		case "EQ_ROCKHERMIT_SCANNER": 
			{ 
			if(worldScripts["rockHermit_Locator"]) 
				{ 
				if(worldScripts["rockHermit_Locator"].version === "1.2.3")
					{
					worldScripts["rockHermit_Locator"].shipLaunchedFromStation() // use the inbuild scripting of the OXP to restart it.
					}
				else
					{
					this.beacons = system.shipsWithPrimaryRole("rockbeacof"); // list the inactive beacons (no lights or "R" on compass) 
					if(this.beacons.length > 0) 
						{ 
						for (let i=0; i<this.beacons.length;i++) 
							{ 
							if (oolite.compareVersion('1.73') <= 0) 
								{
								this.beacons[i].position = this.beacons[i].position.multiply(100); //throw the rockbeacof into space... 
								}
							else 
								{
								this.beacons[i].setPosition(this.beacons[i].position.multiply(100)); //throw the rockbeacof into space... 
						            }

							this.beacons[i].explode(); //...and blow it up. 
							} 
						} 
					worldScripts["rockHermit_Locator"].buoy = "rockbeacon" 
					worldScripts["rockHermit_Locator"].addBuoys() // no inactive beacons, so use original code to add active beacons. 
					}
				break; 
				} 
			}
		}
	}